//
//  AuthorizedTasks.h
// added to CVS on 10/18/03

#import <Cocoa/Cocoa.h>
#import <Security/Authorization.h>

@interface AuthorizedTasks : NSObject {
    AuthorizationRef authorizationRef;
}

// Find out if the user has the appropriate authorization rights.
// This really needs to be called each time you need to know whether the user
// is authorized, since the AuthorizationRef can be invalidated elsewhere, or
// may expire after a short period of time.
- (BOOL)isAuthenticated;


    // if the user is not already authorized, ask them to authenticate.
    // return YES if the user is (or becomes) authorized.
    //
- (BOOL)authenticate;


    // Invalidate the user's AuthorizationRef to dispose of any acquired rights.
    // It's a good idea to do this before you quit your application, else they
    // will stay authorized as of the current time (4K78).
    //
- (void)deauthenticate;

-(BOOL)authenticatedCronWriter;
- (void)authenticatedLogDeleter;
-(void)dealloc;
@end