/* Controller */
// added to CVS on 10/18/03

#import <Cocoa/Cocoa.h>

extern NSString *PSXDonationAlert;
extern NSString *PSXNeverShowDeleteFlagAlert;
extern NSString *PSXServerToCheck;

@class CronController;

@interface Controller : NSObject
{
    IBOutlet id fromField;
    IBOutlet id toField;
    IBOutlet NSTableView *tableView;
    IBOutlet NSTextView *textView;
    
    // Window outlets
    IBOutlet id mainWindow;
    IBOutlet id backupWindow;
    IBOutlet id deleteFlagAlertWindow;
    IBOutlet id backupLogWindow;

    IBOutlet NSButton *newBackup;
    IBOutlet NSButton *editBackup;
    IBOutlet NSButton *deleteBackup;
    IBOutlet NSButton *saveBackup;
    IBOutlet NSButton *runBackup;

    BOOL jobType; // used to specify whether our job is new or existing
		  // True = new
		  // False = existing
    
    IBOutlet NSTextField *backupFrom;
    IBOutlet NSTextField *backupTo;
    IBOutlet NSButton *backupRemoteBackup;
    IBOutlet NSButton *backupForceCopy;
    IBOutlet NSButton *backupDeleteNonExistantFiles;
    IBOutlet NSButton *backupRunAsRoot;

    IBOutlet NSButton *backupScheduleToggle;
    IBOutlet NSPopUpButton *backupDayMenu;
    IBOutlet NSPopUpButton *backupHourMenu;
    IBOutlet NSPopUpButton *backupMinuteMenu;

    IBOutlet NSButton *backupOkayButton;
    
    IBOutlet NSTextField *deleteFlagAlertText;
    IBOutlet NSButton *deleteFlagCheckBox;
    
    CronController *cronJobs;
}
//- (id)init;

-(void)awakeFromNib;

-(void)applicationDidFinishLaunching:(NSNotification *)aNotification;

    // Backup functions
-(IBAction)openNewBackupSheet:(id)sender;
-(IBAction)openExistingBackupSheet:(id)sender;

-(IBAction)saveBackupSheet:(id)sender;

-(IBAction)deleteFlagAlert:(id)sender;
-(IBAction)deleteFlagAlertContinue:(id)sender;
-(IBAction)deleteFlagAlertCancel:(id)sender;

-(IBAction)closeSheet:(id)sender;
-(IBAction)toggleEnabledDisabled:(id)sender;

-(IBAction)backupToSetter:(id)sender;
-(IBAction)backupFromSetter:(id)sender;

    // Related to running backups
-(IBAction)saveChanges:(id)sender;
-(IBAction)runBackupNow:(id)sender;

-(IBAction)deleteBackup:(id)sender;

    // Menu items and related
-(IBAction)showLogWindow:(id)sender;
-(IBAction)deleteLog:(id)sender;

-(IBAction)checkVersion:(id)sender;
-(IBAction)showHelp:(id)sender;
-(IBAction)sendFeedback:(id)sender;
-(IBAction)donateMoney:(id)sender;

// used by the Menu Items to validate our menu items
-(BOOL)validateMenuItem:(NSMenuItem *)item;

// delegate method for our table view
-(void)tableViewSelectionDidChange:(NSNotification *)aNotification;

// delegate method for our application
-(BOOL)applicationShouldTerminateAfterLastWindowClosed:(NSApplication *)app;
				   /*- (BOOL)tableView:(NSTableView *)tableView writeRows:(NSArray*)rows toPasteboard:(NSPasteboard*)pboard;
- (NSDragOperation)tableView:(NSTableView*)tableView validateDrop:(id <NSDraggingInfo>)info proposedRow:(int)row proposedDropOperation:(NSTableViewDropOperation)operation;
- (BOOL)tableView:(NSTableView*)tableView acceptDrop:(id <NSDraggingInfo>)info row:(int)row dropOperation:(NSTableViewDropOperation)operation;*/
-(void)dealloc;
@end

@interface Controller (Private)
-(void)updateInterface;

-(void)_donationSheetDidEnd:(NSWindow *)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo;

-(void)_resetBackupWindow:(NSString *)temp;
-(void)_setupBackupWindow;
-(void)_closeASheet;

@end
