//
//  CronJob.h
//  PsyncX
//
//  Copyright (c) 2003 AcornSoft. All rights reserved.
//
// added to CVS on 10/18/03

#import <Foundation/Foundation.h>

@interface CronJob : NSObject {
    NSString *enabledDisabled;
    NSString *minutes;
    NSString *hours;
    NSString *monthDay;
    NSString *month;
    NSString *weekDay;
//    NSString *who;
    NSString *command;
    // Flags go FDR (as in the president)
    int fFlag;
    int dFlag;
    int rFlag;
    NSString *from;
    NSString *to;
	BOOL needToSave;
	int runAsRoot;
}

-(id)init;

-(void)parseOldJob:(NSString *)job;
-(void)parseJob:(NSString *)job;

-(NSString *)cronJob;
-(NSString *)regularJob;

-(BOOL)needToSave;
-(void)setNeedToSave:(BOOL)needSave;

-(NSString *)enabledDisabledString;
-(int)enabledDisabled;
-(void)setEnabledDisabledString:(NSString *)enDis;
-(void)setEnabledDisabled:(int)i;

// The reason we have to have these as strings is because we wouldn't
// be able to allow people to setup */2, etc if we didn't
// (okay, maybe we could, but it wouldn't be easy)
// on the other hand, it would be so much more efficient :-/
-(NSString *)minutes;
-(void)setMinutes:(NSString *)min;

-(NSString *)hours;
-(void)setHours:(NSString *)hr;

-(NSString *)monthDay;
-(void)setMonthDay:(NSString *)monDay;

-(NSString *)month;
-(void)setMonth:(NSString *)mon;

-(NSString *)weekDay;
-(void)setWeekDay:(NSString *)wday;

-(NSString *)runAsRoot;
-(int)runAsRootState;
-(void)setRunAsRoot:(NSString *)who;
-(void)setRunAsRootState:(int)asRoot;

-(NSString *)command;
-(void)setCommand:(NSString *)cmd;

-(NSString *)fFlag;
-(int)fFlagState;

-(NSString *)dFlag;
-(int)dFlagState;

-(NSString *)rFlag;
-(int)rFlagState;

-(void)setFlag:(NSString *)flag toValue:(NSString *)value;
-(void)setFlag:(NSString *)flag toState:(int)state;

-(NSString *)from;
-(void)setFrom:(NSString *)fr;

-(NSString *)to;
-(void)setTo:(NSString *)t;

-(void)dealloc;
@end

@interface CronJob (Private)
-(NSString *)_addSingleQuotes:(NSString *)t;
-(NSString *)_stripSingleQuotes:(NSString *)t;
-(NSString *)_removeSpaces:(NSString *)temp;
-(NSString *)_escapeDoubleQuotes:(NSString *)t;
@end