//
//  CronJob.m
//  PsyncX
//
//  Created by $Author: dbaker $ on $Date: 2006/07/04 17:33:39 $
//  Copyright (c) 2003 AcornSoft. All rights reserved.
//
// added to CVS on 10/18/03

#import "CronJob.h"

@implementation CronJob

-(id)init;
{
    if(self = [super init]) {
		[self setEnabledDisabledString:@"#"];
		[self setCommand:@"/usr/local/bin/runpsync"];
/*		[self setFFlag:@""];
		[self setDFlag:@""];
		[self setRFlag:@""];*/
		[self setFlag:@"f" toState:0];
		[self setFlag:@"d" toState:0];
		[self setFlag:@"r" toState:0];
		[self setMinutes:@"0"];
		[self setHours:@"0"];
		[self setMonthDay:@"*"];
		[self setMonth:@"*"];
		[self setWeekDay:@"*"];
		[self setRunAsRootState:1];
		[self setNeedToSave:FALSE];
    }
    return self;
}

-(void)parseOldJob:(NSString *)job;
{
    NSArray *cronCommands;
    NSString *temporary;
    // Initialize our cronItems array
    // Splits our job into our array
    
    // We used to have the lines seperated by five spaces
    NSMutableArray *cronItems = [NSMutableArray arrayWithArray:[job componentsSeparatedByString:@"    "]];
    
    // And before that we had them setup with three spaces
    if([cronItems count]<3) {
	[cronItems setArray:[job componentsSeparatedByString:@"   "]];
    }
    
    // Split the first item up to see if this has been commented out
    temporary=[NSString stringWithString:[cronItems objectAtIndex:0]];
    
    // If there is a # sign at the beginning, this job has been disabled
    if([temporary hasPrefix:@"#"])
    {
		[self setEnabledDisabledString:@"#"];
		[self setMinutes:[self _removeSpaces:[temporary substringFromIndex:1]]];
    }
    // Otherwise, we have a regular enabled job
    else
    {
		[self setEnabledDisabledString:@""];
		[self setMinutes:[self _removeSpaces:temporary]];
    }
    
    // then we set our object up
    [self setHours: [cronItems objectAtIndex:1]];
    [self setMonthDay:[self _removeSpaces:[cronItems objectAtIndex:2]]];
    [self setMonth:[self _removeSpaces:[cronItems objectAtIndex:3]]];
    [self setWeekDay:[self _removeSpaces:[cronItems objectAtIndex:4]]];
    [self setRunAsRoot:[self _removeSpaces:[cronItems objectAtIndex:5]]];
    
    cronCommands=[[cronItems objectAtIndex:6] componentsSeparatedByString:@" "];
    
    [self setCommand:[self _removeSpaces:[cronCommands objectAtIndex:0]]];
    [self setFlag:@"f" toValue:[self _removeSpaces:[cronCommands objectAtIndex:1]]];
    [self setFlag:@"d" toValue:[self _removeSpaces:[cronCommands objectAtIndex:2]]];
    [self setFlag:@"r" toValue:[self _removeSpaces:[cronCommands objectAtIndex:3]]];
    
    [self setFrom:[cronCommands objectAtIndex:4]];
    [self setTo:[cronCommands objectAtIndex:5]];
	[self setNeedToSave:FALSE];
    
    //	[cronCommands autorelease];
}
-(void)parseJob:(NSString *)job;
{
    NSArray *cronCommands;
    NSArray *cronCommands2;
    int i=0;
    NSMutableString *temp2;
    NSArray *cronItems;
    // Initialize our cronItems array
    // Splits our job into our array

	@try {
		cronItems = [job componentsSeparatedByString:@"\t"]; //these are awfully fragile if a job gets re-pasted in
	}
	@catch (NSException *e) {
		if ([[e name] isEqualToString:NSRangeException]) {
			NSRunAlertPanel(@"We had problems reading in your old jobs", @"%@", @"OK", nil, nil, e);
			return; // we'll just forget those jobs for now, we'll come back and clean this up later
		}
	}
	@finally {
	}
    
    // Split the first item up to see if this has been commented out
    NSString *temp=[NSString stringWithString:[cronItems objectAtIndex:0]];
    
    // If there is a # sign at the beginning, this job has been disabled
    if([temp hasPrefix:@"#"])
    {
		[self setEnabledDisabledString:@"#"];
		[self setMinutes: [temp substringFromIndex:1]];
    }
    // Otherwise, we have a regular enabled job
    else
    {
		[self setEnabledDisabledString:@""];
		[self setMinutes: temp];
    }
    
    // then we set our object up
    [self setHours: [cronItems objectAtIndex:1]];
    [self setMonthDay: [cronItems objectAtIndex:2]];
    [self setMonth: [cronItems objectAtIndex:3]];
    [self setWeekDay: [cronItems objectAtIndex:4]];
    [self setRunAsRoot: [cronItems objectAtIndex:5]];
    

	@try {
		cronCommands=[[cronItems objectAtIndex:6] componentsSeparatedByString:@" "];
	}
	@catch (NSException *e) {
		if ([[e name] isEqualToString:NSRangeException]) {
			NSLog(@"Couldn't read that job");
			//			NSRunAlertPanel(@"", @"We had problems reading in your old jobs", @"OK", nil, nil); // deal with this later
			return; // we'll just forget those jobs for now, we'll come back and clean this up later
			// we'll also have to take our job out of CronController :-/
		}			
	}
	@finally {
	}

    [self setCommand: [cronCommands objectAtIndex:0]];
    [self setFlag:@"f" toValue:[cronCommands objectAtIndex:1]];
    [self setFlag:@"d" toValue:[cronCommands objectAtIndex:2]];
    [self setFlag:@"r" toValue:[cronCommands objectAtIndex:3]];
    
    temp2=[NSMutableString stringWithString:@""];
    
    // Join it back together again
    for(i=4;i<[cronCommands count];i++) {
	[temp2 appendFormat:@" %@", [cronCommands objectAtIndex:i]];
    }
    cronCommands2=[temp2 componentsSeparatedByString:@" '"];
    
    
    [self setFrom: [cronCommands2 objectAtIndex:1]];
    [self setTo: [cronCommands2 objectAtIndex:2]];
	[self setNeedToSave:FALSE];
}

-(NSString *)cronJob;
{
    // returns our cronjob in crontab format
    return [NSString stringWithFormat:@"%@%@\t%@\t%@\t%@\t%@\t%@\t%@ %@ %@ %@ %@ %@", [self enabledDisabledString], [self minutes], [self hours], [self monthDay], [self month], [self weekDay], [self runAsRoot], [self command], [self fFlag], [self dFlag], [self rFlag], [self _addSingleQuotes:[self from]], [self _addSingleQuotes:[self to]]];
}

-(NSString *)regularJob;
{
	// this can't necessarily have sudo!!!
	NSString *tmp;
	if ([self runAsRootState]) {
		tmp=[NSString stringWithFormat:@"sudo %@",[self command]];
	}
	else
	{
		tmp=[[self command] autorelease];
	}
    return [NSString stringWithFormat:@"%@ %@ %@ %@ %@ %@", tmp, [self fFlag], [self dFlag], [self rFlag], [self _escapeDoubleQuotes:[self _addSingleQuotes:[self from]]], [self _escapeDoubleQuotes:[self _addSingleQuotes:[self to]]]];
}

// Getters/setters
-(NSString *)enabledDisabledString;
{
    return enabledDisabled;
}
-(int)enabledDisabled;
{
    if([enabledDisabled isEqualToString:@"#"]) {
	return 0;
    }
    else {
	return 1;
    }
}
-(void)setEnabledDisabledString:(NSString *)enDis;
{
	if (enabledDisabled==enDis || [enabledDisabled isEqualToString:enDis]) {
		return;
	}
    [enabledDisabled release];
    enabledDisabled = [enDis copy]; // using this per Wil Shipley: http://wilshipley.com/blog/2005/12/pimp-my-code-part-6-pimp-before.html
	[self setNeedToSave:TRUE];
}
-(void)setEnabledDisabled:(int)i;
{
	if ([self enabledDisabled]==i) { // try to catch the thing we already had
		return;
	}
    if(i==1) {
		[self setEnabledDisabledString:@""];
    }
    else {
		[self setEnabledDisabledString:@"#"];
    }
}

-(BOOL)needToSave;
{
	return needToSave;
}
-(void)setNeedToSave:(BOOL)needSave;
{
	if(needToSave==needSave) {
		return;
	}
	needToSave=needSave;
}

-(NSString *)minutes;
{
    return minutes;
}
-(void)setMinutes:(NSString *)min;
{
	if (min==minutes || [minutes isEqualToString:min]) {
		return;
	}
    [minutes release];
    minutes = [min copy];
	[self setNeedToSave:TRUE];
}

-(NSString *)hours;
{
    return hours;
}
-(void)setHours:(NSString *)hr;
{
	if (hours==hr || [hours isEqualToString:hr]) {
		return;
	}
    [hours release];
    hours = [hr copy];
	[self setNeedToSave:TRUE];
}

-(NSString *)monthDay;
{
    return monthDay;	
}
-(void)setMonthDay:(NSString *)monDay;
{
	if (monthDay==monDay || [monthDay isEqualToString:monDay]) {
		return;
	}
    [monthDay release];
    monthDay = [monDay copy];
	[self setNeedToSave:TRUE];
}

-(NSString *)month;
{
    return month;
}
-(void)setMonth:(NSString *)mon;
{
	if (month==mon || [month isEqualToString:mon]) {
		return;
	}
    [month release];
    month = [mon copy];
	[self setNeedToSave:TRUE];
}

-(NSString *)weekDay;
{
    return weekDay;	
}
-(void)setWeekDay:(NSString *)wday;
{
	if (weekDay==wday || [weekDay isEqualToString:wday]) {
		return;
	}
    [weekDay release];
    weekDay = [wday copy];
	[self setNeedToSave:TRUE];
}

-(NSString *)runAsRoot;
{
	if (runAsRoot==1) {
		return [NSString stringWithString:@"root"];
	}
	else
	{
		return NSUserName();
	}
}
-(int)runAsRootState;
{
	return runAsRoot;
}
-(void)setRunAsRoot:(NSString *)who;
{
	if ([who isEqualToString:@"root"]) {
		[self setRunAsRootState:1];
	}
	else
	{
		[self setRunAsRootState:0];
	}
}
-(void)setRunAsRootState:(int)asRoot;
{
	if (runAsRoot==asRoot) {
		return;
	}
	runAsRoot=asRoot;
	[self setNeedToSave:TRUE];
}

-(NSString *)command;
{
    return command;
}
-(void)setCommand:(NSString *)cmd;
{
	if (command==cmd  || [command isEqualToString:cmd ]) {
		return;
	}
    NSMutableString *temp2=[NSMutableString stringWithString:cmd];
    [temp2 replaceOccurrencesOfString:@"/usr/bin/runpsync" withString:@"/usr/local/bin/runpsync" options:NSLiteralSearch range:NSMakeRange(0, [temp2 length])];
    [command release];
    command = [[NSString stringWithString:temp2] retain];
	[self setNeedToSave:TRUE];
}

-(NSString *)fFlag;
{
	if (fFlag==1) {
		return [NSString stringWithString:@"-f"];
	}
	else
	{
		return [NSString stringWithString:@"0"];		
	}
}
-(int)fFlagState;
{
	return fFlag;
}

-(NSString *)dFlag;
{
	if (dFlag==1) {
		return [NSString stringWithString:@"-d"];
	}
	else
	{
		return [NSString stringWithString:@"0"];		
	}
}
-(int)dFlagState;
{
	return dFlag;
}

-(NSString *)rFlag;
{
	if (rFlag==1) {
		return [NSString stringWithString:@"-r"];
	}
	else
	{
		return [NSString stringWithString:@"0"];		
	}
}
-(int)rFlagState;
{
	return rFlag;
}

// we store our variables as ints, but we have to receive and send strings for a cron job.  So we deal with that here
-(void)setFlag:(NSString *)flag toValue:(NSString *)value;
{
	if([value isEqualToString:@"-f"]) {
		[self setFlag:@"f" toState:1];
	}
	else if([value isEqualToString:@"-d"]) {
		[self setFlag:@"d" toState:1];
	}
	else if([value isEqualToString:@"-r"]) {
		[self setFlag:@"r" toState:1];
	}
	else
	{
		[self setFlag:flag toState:0];
	}	
}
-(void)setFlag:(NSString *)flag toState:(int)state;
{
	if([flag isEqualToString:@"f"]) {
		if(fFlag==state) {
			return;
		}
		if(state!=1 && state!=0) {
			return;
		}
		fFlag=state;
	}
	if([flag isEqualToString:@"d"]) {
		if(dFlag==state) {
			return;
		}
		if(state!=1 && state!=0) {
			return;
		}
		dFlag=state;
	}
	if([flag isEqualToString:@"r"]) {
		if(rFlag==state) {
			return;
		}
		if(state!=1 && state!=0) {
			return;
		}
		rFlag=state;
	}
	[self setNeedToSave:TRUE];
}

-(NSString *)from;
{
    return from;
}
-(void)setFrom:(NSString *)fr;
{
	if (from==fr || [from isEqualToString:fr]) {
		return;
	}
    [from release];

    from = [[[self _stripSingleQuotes:fr] stringByExpandingTildeInPath] copy];
	[self setNeedToSave:TRUE];
}

-(NSString *)to;
{
    return to;
}
-(void)setTo:(NSString *)t;
{
	if (to==t || [to isEqualToString:t]) {
		return;
	}
    [to release];
    to = [[[self _stripSingleQuotes:t] stringByExpandingTildeInPath] copy];
	[self setNeedToSave:TRUE];
}

// have to be diligent about memory management!
-(void)dealloc;
{
    [enabledDisabled release];
    [minutes release];
    [hours release];
    [monthDay release];
    [month release];
    [weekDay release];
//    [who release];
    [command release];
/*    [fFlag release];
    [dFlag release];
    [rFlag release];*/
    [from release];
    [to release];
    [super dealloc];
}

@end

@implementation CronJob (Private)

-(NSString *)_addSingleQuotes:(NSString *)t;
{
    NSMutableString *temp=[NSMutableString stringWithString:t];
    //NSMutableString *temp2=[NSMutableString stringWithCString:"\\"];
    //[temp2 appendString:@"'"];
    
    // Escape any single-quote characters
    // Need the \\ to escape our \ character
    [temp replaceOccurrencesOfString:@"'" withString:@"\\'" options:NSLiteralSearch range:NSMakeRange(0, [temp length])];
    
    // Add our single quotes at the front and back
    [temp insertString:@"'" atIndex:0];
    [temp appendString:@"'"];
    
    return temp;
}
// We call this from both the setTo and the setFrom functions
-(NSString *)_stripSingleQuotes:(NSString *)t;
{
    NSMutableString *temp=[NSMutableString stringWithString:t];
    // This removes the single quote (if any) from the beginning of the variable
    if([temp hasPrefix:@"'"]) {
		[temp setString:[temp substringFromIndex:1]];
    }
    // This removes the single quote (if any) from the end of the variable
    if([temp hasSuffix:@"'"]) {
		[temp setString:[temp substringToIndex:[temp length]-1]];
    }
    
    // Need the \\ to escape our \ character
    [temp replaceOccurrencesOfString:@"\\'" withString:@"'" options:NSLiteralSearch range:NSMakeRange(0, [temp length])];
    return temp;
}

-(NSString *)_removeSpaces:(NSString *)temp;
{
    NSMutableString *temp2=[NSMutableString stringWithString:temp];
    [temp2 replaceOccurrencesOfString:@" " withString:@"" options:NSLiteralSearch range:NSMakeRange(0, [temp length])];
    return temp2;
}

-(NSString *)_escapeDoubleQuotes:(NSString *)t;
{
    NSMutableString *temp=[NSMutableString stringWithString:t];
    //NSMutableString *temp2=[NSMutableString stringWithCString:"\\"];
    //[temp2 appendString:@"'"];
    
    // Escape any single-quote characters
    // Need the \\ to escape our \ character
    [temp replaceOccurrencesOfString:@"\"" withString:@"\\\"" options:NSLiteralSearch range:NSMakeRange(0, [temp length])];

    return temp;
}

@end